#include <windows.h>
//#include <stdio.h>

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	bool wait = false;
	if (!strncmp(lpCmdLine, "/wait ", 6))
	{
		wait = true;
		lpCmdLine += 6;
	}
	
	STARTUPINFO si = { sizeof(STARTUPINFO) };
	si.dwFlags = STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_HIDE;
	PROCESS_INFORMATION pi;
	if (!CreateProcess(NULL, lpCmdLine, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
	{
		//printf("Error %l, command not executed.\n", GetLastError());
		// Doesn't print anything anyway -> TODO: use OutputDebugString()
		return 127;
	}

	if (wait)
	{
		// Join on the process and return its exit code
		if (WaitForSingleObject(pi.hProcess, INFINITE) == WAIT_FAILED)
		{
			// TODO: Use OutputDebugString() to print error code
			return 127;
		}

		DWORD exitCode = 0;
		if (GetExitCodeProcess(pi.hProcess, &exitCode))
		{
			return exitCode;
		}
		else
		{
			// TODO: Use OutputDebugString() to print error code
			return 127;
		}
	}
	else
	{
		return 0;
	}
}
